///////////////////////////////////////////////
Config.appid = "Home";
Config.title = "Home";
Config.version = "1";

///////////////////////////////////////////////
function Home() {}
Home.welcome = function() {
	welcome();
}

Home.settings = function() {
	settings();
}

Home.main = function() {
	main();
}

///////////////////////////////////////////////
function main() {
	if (Settings.isTablet()) {
		signIn();
		return;
	} else {
		if (Settings.getUsername() != null) {
			appList();
		} else {
			welcome();
	    }
	}
}
 
function leftPane() {
	if (Settings.getUsername() == null) {
		List.addItem(R.SIGNIN, 'main()');
		List.addItem(R.CREATEACCOUNT, 'createAccount()');
	}
	List.show("leftpane");
}

function isNovade() {
	var oem = Settings.getOem();
	return oem == "com.upvise.novade";
}

function welcome() {
	var title = "Upvise pro";
	if (isNovade() == true) title = "Novade";
    Toolbar.setTitle(title);
    List.addTextBox('email', R.EMAIL, '','','email');
    List.addTextBox('password', R.PASSWORD, '','','password');
    List.addButton(R.SIGNIN, 'onSignIn()');
    if (isNovade() == false) {
    	List.addHeader("No account yet?");
    	List.addButton(R.CREATEACCOUNT, 'createAccount()');
    }
    List.show("form"); // form param for text inplace editing
}

function signIn() {
	List.addTextBox('email', R.EMAIL, '','','email');
    List.addTextBox('password', R.PASSWORD, '','','password');
    List.addButton(R.SIGNIN, 'onSignIn()');
    List.show("form");
}

function onSignIn() {
    var email = List.getValue('email');
    var password = List.getValue('password');
    App.signIn(email, password);
}

function createAccount() {
	List.addTextBox('email', R.EMAIL, '','','email');
    List.addTextBox('password', R.PASSWORD, '','','password');
    List.addTextBox('company', R.COMPANY, '','','text');
    List.addButton(R.CREATEACCOUNT, 'onCreateAccount()');
    List.show("form");
}

function onCreateAccount() {
    var email = List.getValue('email');
    var password = List.getValue('password');
    var company = List.getValue('company');
    App.signUp(email, password, company);
}

///////////////////

function settings() {
	if (isNovade()) {
		settingsNovade();
		return;
	}
	
	var onchange = "Settings.set(this.id,this.value)";
	
	Toolbar.setTitle(R.SETTINGS);
	List.addComboBox('syncmode', R.SYNC, Settings.get('syncmode'), onchange, "0:" + R.AUTOMATIC + "|1:" + R.WIFI + "|2:" + R.MANUAL);
	List.addComboBox('location.mode', R.LOCATION, Settings.get('location.mode'), onchange, "0:" + R.CELLULAR + "|1:" + R.GPS);
	List.addCheckBox('location.share', R.SHARELOCATION, Settings.get("location.share")=="1", onchange);
	List.addComboBox('notifmode', R.NOTIFICATIONS, Settings.get('notifmode'), onchange, "0:" + R.SOUND + "|1:" + R.SILENT + "|2:" + R.OFF);
	 
	List.addHeader(Settings.get("email"));
	List.addButton(R.SIGNOUT, "App.signOut()");
	//List.addButton(R.CHANGEPASSWORD, "changePassword()", "color:gray");
	
	List.addHeader(R.PHONECALLS);
	//List.addComboBox('incomingcall', R.ONINCOMINGCALL, Settings.get('incomingcall'), onchange, "0:" + R.DONOTHING + "|1:" + R.SHOWCONTACTINFO);
	List.addComboBox('callend', R.ONCALLEND, Settings.get('callend'), onchange, "0:" +  R.DONOTHING + "|1:" + R.SHOWFOLLOWUPACTIONS);
	List.addComboBox('smsreceived', R.ONSMSRECEIVED, Settings.get('smsreceived'), onchange, "0:" +  R.DONOTHING + "|1:" + R.ATTACHNOTEASCONTACT);
	List.addCheckBox('bcc', R.BCCDROPBOX, Settings.get("bcc")=="1", onchange);
	
	List.addHeader(R.SECURITY);
	List.addComboBox('https', R.USEHTTPS, Settings.get('https'), onchange, "0:No|1:Yes");
	
	if (Settings.getPlatform() != "windowsphone") {
		var passcode = Settings.get("passcode");
		if (passcode == null || passcode.length == 0) {
			List.addItemLabel(R.PASSCODE, "No", "App.changePasscode()");
		} else {
			List.addItemLabel(R.PASSCODE, "Yes", "showPasscodeOptions()");
		}
	}
	List.addHeader("Menu");
	List.addCheckBox('menu.refresh', R.SHOWREFRESHMENU,  Settings.get("menu.refresh")=="1", onchange);
	List.addCheckBox('menu.home', R.SHOWHOMEMENU,  Settings.get("menu.home")=="1", onchange);
		
	List.addHeader(R.ABOUT);
	List.addItemLabel(R.VERSION, Settings.getVersion());
	
	List.show();
}

function showPasscodeOptions() {
	List.addItem("Turn Off", "App.turnOffPasscode()");
	List.addItem("Change", "App.changePasscode()");
	List.show("popup");
}


/////////////////////

function settingsNovade() {
	var onchange = "Settings.set(this.id,this.value)";
	
	Toolbar.setTitle(R.SETTINGS);
	List.addHeader(Settings.get("email"));
	List.addButton(R.SIGNOUT, "App.signOut()");
	List.addButton(R.CHANGEPASSWORD, "changePassword()", "color:gray");
	List.addHeader(R.ABOUT);
	List.addItemLabel(R.VERSION, Settings.getVersion());
	List.show();
}

////////////////////

function changePassword() {
	List.addTextBox("pwd", "Current Password", "", "", "password");
    List.addTextBox("newpwd", "New Password", "", "", "password");
    List.addTextBox('newpwd2', "Confirm Password", "", "", "password");
    List.addButton("Change Password", "onChangePassword()");
    List.show("form");
}

function onChangePassword() {
    var pwd = List.getValue("pwd");
    var newpwd = List.getValue("newpwd");
    var newpwd2 = List.getValue("newpwd2");
    if (pwd == "") {
    	App.alert("Please enter current password");
    	return;
    }
    if (newpwd != newpwd2) {
   		App.alert("Passwords do not match");
    	History.reload();
    	return;
   	}
   	if (newpwd.length < 7) {
    	App.alert("Password must be 7 char length minimum");
    	History.reload();
    	return;
   	}
   	App.changePassword(pwd, newpwd);

}


