﻿Config.appid = "sony";
Config.title = "Explore By Sony";
Config.version = "8";

Config.tables["products"] = "id;name;code;categoryid;shortdescription;description;thumbnail;price REAL;currency;rating INTEGER;popular INTEGER;parentid;seriesid;colors;promotionid;introdate DATE;url";
Config.tables["productimages"] = "id;productid;rank INTEGER;imgurl;color";
Config.tables["categories"] = "id;name;rank INTEGER;imgurl;thumbnail;parentid;haschild INTEGER;description;csvid;hasSeries INTEGER";
Config.tables["groups"] = "id;name;rank INTEGER;thumbnail;csvid";
Config.tables["priceranges"] = "id;min INTEGER;max INTEGER;categoryid";
Config.tables["promotions"] = "id;name;description;startdate DATE;enddate DATE;imgurl;url;type INTEGER;code";
Config.tables["reviews"] = "id;productid;name;author;description;date DATE;rating INTEGER";
Config.tables["stores"] = "id;name;type;address;phone;businesshours;geo;zoneid;cityid;promourl;startdate DATE;enddate DATE;categoryid";
Config.tables["zones"] = "id;name";
Config.tables["cities"] = "id;name;zoneid";
Config.tables["polls"] = "id;name;date DATE;type INTEGER";
Config.tables["pollchoices"] = "id;pollid;name;votecount INTEGER";
Config.tables["videos"] = "id;url;name;categoryid;productid";
Config.tables["videocategories"] = "id;name;url";

Config.tables["assets"] = "id;name;imgurl;description;groupid;url;productid;rank INTEGER";
Config.tables["assetgroups"] = "id;name;imgurl;categoryid;description;rank INTEGER";

Config.tables["series"] = "id;name;categoryid";

Config.tables["supportconfig"] = "id;name;url;type;rank INTEGER;link";

function Sony() {}

Sony.viewProduct = function (id) {
    viewProduct(id);
}

function v(id) {
    viewProduct(id);
}

/////////////////////////////////////////////////

function main() {
    // try to get country from settings or from phone locale
    var country = getCountry();

    if (country == 'za' || country == 'ir') {
        if (Settings.getPlatform() == "mobileweb") {
            addCss('ltr');
            List.addItem('This website is not available');
        } else {
            List.addItem('This page is not available');
        }
        List.show();
        return;
    } else if (country == 'tw') {
        window.location = "support/default.htm";
        return;
    }
    
    if (Settings.getPlatform() == "mobileweb") {
        SyncEngine.BATCH_URL = "http://sony.upvise.com/uws/batch"; // URL of the UW batch web service

        if (country == "mea") {
            selectLanguage("mea");
            return;
        } else if (country == "africa") {
            selectLanguage("africa");
            return;
        }

        // Load CSS for MEA if required
        if (country == 'me-ar' || country == 'ir') {
            addCss('rtl');
        } else {
            addCss('ltr');
        }
    }

    // set the current country
    setCountry(country);

    _orderByLabel = R.LATEST;

    if (Settings.getPlatform() == "mobileweb") {
        History.replace("mainMobileWeb()");
        return;
    }

    //var promos = Query.select("promotions", "id;imgurl", "type=2 AND startdate<={today()} AND enddate>={today()}", "startdate");
    // We want to display the first promo in order of RSS feed - so order by startdate
    var promos = Query.select("promotions", "id;imgurl", "type=2 AND startdate<100", "startdate"); // Start date = 0, 1, 2,... for RSS feed
    var homePromo = (promos.length > 0) ? promos[0] : null;
    if (homePromo == null) {
        promos = Query.select("promotions", "id;imgurl", "type=2 AND startdate<={today()} AND enddate>={today()}", "startdate DESC");  //or start=datetime for manually entered promos
        homePromo = (promos.length > 0) ? promos[0] : null;
    }
    
    var products = getHomePageProducts(homePromo != null ? homePromo.id : null);
    var welcome = "Sony " + getCountryName();
    Toolbar.setTitle("SONY");
    if (promos.length > 0) List.addImage(promos[0].imgurl, "viewPromotion({promos[0].id})");
    List.addItemLabel(welcome, Format.text(R.SEARCH));
    for (var i = 0; i < products.length; i++) {
        _writeProduct(products[i]);
    }

    Toolbar.addButton("Search", "search('')", "search");

    if (Settings.isTablet() == false) {
        // custom sidebar items on native app
        addSideBarItems();

        List.addItem(R.MOREPRODUCTS, "viewProducts()", "icon=arrow");
        Toolbar.addTab(R.PRODUCTS2, "viewProducts()");
        Toolbar.addTab(R.PROMOTIONS, "viewPromotions()");
        Toolbar.addTab(R.STORES, "viewStoreLocator()");


        List.addHeader(R.MORE);
        List.addItem(R.SUPPORT, "viewSupport()");
        List.addItem(R.VIDEOS, "viewVideos()");
        List.addItem(R.NEWS, "viewNews()");
        //List.addItem(R.TECHNOLOGY, "viewTechnologies()");
    }

    // TEST
    //List.addItem("My Sony", "Account.viewAccount()");
    List.show();
    LeftPane.write();
    App.track("/home");
}

function leftPane() {}

function customStartPage(hash) {
    if (hash == null || hash.length <= 3) return false;

    hash = hash.substring(1).toLowerCase(); // remove the #

    CoreEngine.hash = null; // reset the hash

    // Try Support and Stores
    if (hash == "stores") {
        History.replace("viewStoreLocator()");
        return true;
    }
    
    if (hash == "support") {
        History.replace("viewSupport()");
        return true;
    }

    // 2. Try Promo code
    var promos = Query.select("promotions", "id;code");
    for (var i = 0; i < promos.length; i++) {
        var promo = promos[i];
        if (hash == promo.code) {
            History.replace("viewPromotion({promo.id})");
            return true;
        }
    }

    // 2. Try with SKU match
    var products = Query.select("products", "id");
    for (var i = 0; i < products.length; i++) {
        var product = products[i];
        var productid = product.id.toLowerCase();
        if (productid.indexOf(hash) > -1) {
            History.replace("viewProduct({product.id})");
            return true;
        }
    }

    // 1. try category match
    var categories = Query.select("categories", "id;name");
    for (var i = 0; i < categories.length; i++) {
        var category = categories[i];
        var name = category.name.toLowerCase();
        if (name.indexOf(hash) > -1) {
            History.replace("viewCategory({category.id})");
            return true;
        }
    }

    return false;
}

function mainMobileWeb() {
    if (customStartPage(CoreEngine.hash) == true) {
        return;
    }

    var appStoreLink = null;
    var ua = navigator.userAgent.toLowerCase();
    if ((ua.match(/iPhone/i)) || (ua.match(/iPod/i))) {
        appStoreLink = "http://itunes.apple.com/sg/app/sony-singapore/id442379296?mt=8";
    } else if (ua.indexOf("android") > -1) {
        appStoreLink = "https://market.android.com/details?id=Unyverse.sony";
    }

    //var promos = Query.select("promotions", "id;imgurl", "type=2 AND startdate<={today()} AND enddate>={today()}", "startdate");
    // We want to display the first promo in order of RSS feed - so order by startdate
    var promos = Query.select("promotions", "id;imgurl", "type=2 AND startdate<100", "startdate"); // Start date = 0, 1, 2,... for RSS feed
    var homePromo = (promos.length > 0) ? promos[0] : null;
    if (homePromo == null) {
        promos = Query.select("promotions", "id;imgurl", "type=2 AND startdate<={today()} AND enddate>={today()}", "startdate DESC");  //or start=datetime for manually entered promos
        homePromo = (promos.length > 0) ? promos[0] : null;
    }
    var products = getHomePageProducts(homePromo != null ? homePromo.id : null);

    var country = Settings.get("country");

    var welcome = (country == "ir") ? R.WELCOME : (R.WELCOME + " " + getCountryName()); // Farsi text for R.WELCOME is: "To Sony Iran welcome"

    Toolbar.setTitle(welcome);
    if (homePromo != null) List.addImage(homePromo.imgurl, "viewPromotion({homePromo.id})");
    List.addItemLabel(welcome, R.SEARCH);
    if (Settings.get("country") != "in" && appStoreLink != null) List.addItemLabel(R.GETFASTERACCESS, R.DOWNLOADEXPLORE, "App.web({appStoreLink})");

    for (var i = 0; i < products.length; i++) {
        _writeProduct(products[i]);
    }
    List.addItem(R.MOREPRODUCTS, "viewProducts()", "class=gray");

    Toolbar.addButton(R.VIDEOS, "viewVideos()", "sony_video");
    Toolbar.addButton(R.NEWS, "viewNews()", "sony_news");
    Toolbar.addButton(R.SUPPORT, "viewSupport()", "sony_support");
    //Toolbar.addButton(R.TECHNOLOGY, "viewTechnologies()", "sony_techno");
    Toolbar.addButton(R.FULLSITE, "fullSite()", "sony_site");
    Toolbar.addButton(R.CHANGECOUNTRY, "viewCountries()", "sony_country");
    if (Settings.get("country") == "sg") Toolbar.addButton("Careers", "App.web('http://careers.sony.com.sg/sony/en/listing/')", "sony_careers");
    List.show();

    App.track("/home");
}

function getHomePageProducts(homePromoId) {
    var list = new Array();
    var productsids = new Array(); // array of product ids used to test if a product is already in the list

    // First try the Home Page promos
    if (homePromoId != null) {
        list = Query.select("products", "id;code;name;thumbnail;price;currency;introdate", "promotionid CONTAINS {homePromoId}", "introdate DESC");
    }
    if (list.length >= 5) return list.slice(0, 5);

    // fill in productids array
    for (var i = 0; i < list.length; i++) {
        productsids.push(list[i].id);
    } 

    // Then products for any active promos
    var promos = Query.select("promotions", "id", "type=0 AND startdate<={today()} AND enddate>={today()}", "startdate DESC");
    var rsspromos = Query.select("promotions", "id", "type=0 AND startdate<100", "startdate");
    promos = promos.concat(rsspromos);
    var gifts = Query.select("promotions", "id", "type=3 AND startdate<={today()} AND enddate>={today()}", "startdate DESC");
    promos = promos.concat(gifts);
    for (var i = 0; i < promos.length; i++) {
        var promoid = promos[i].id;
        var products = Query.select("products", "id;code;name;thumbnail;price;currency;introdate", "promotionid CONTAINS {promoid}");
        for (var j = 0; j < products.length; j++) {
            var product = products[j];
            if (productsids.indexOf(product.id) == -1) {
                list.push(product);
                productsids.push(product.id);
            }
            if (list.length >= 5) {
                return list;
            }
        }
    }

    // Then newest products
    var newest = Query.select("products", "id;code;name;thumbnail;price;currency;introdate", "parentid='' AND introdate<{today()}", "introdate DESC");
    for (var j = 0; j < newest.length; j++) {
        var product = newest[j];
        if (productsids.indexOf(product.id) == -1) {
            list.push(product);
            productsids.push(product.id);
        }
        if (list.length >= 5) {
            return list;
        }
    }
    return list;
}


////////////// SEARCH

function search(str) {
    if (Settings.getPlatform() == "mobileweb") {
        if (HistoryManager.current().funcCall == "viewStoreLocator()") {
            onStoreSearch(str);
            return;
        }
    }

    if (str != null && str.length > 0) {
        var count = 0;
        count += writeProdutSearchSection(str, "parentid=''", R.PRODUCTS2);
        count += writeProdutSearchSection(str, "parentid!=''", R.ACCESSORIES);
        count += writeStoreSearchSection(str, "type!=3", R.STORES); // not service center
        // TODO : News & Videos
        if (count == 0) List.addItem(R.NORESULTS);
    }
    Toolbar.setSearch("Search Anything", str, "search");
    List.show();
}

function writeProdutSearchSection(search, where, title) {
    var products = Query.search("products", search, "name;code;shortdescription", where, "introdate DESC");
    var count = Math.min(products.length, 10);
    if (count > 0) List.addHeader(title + " (" + count + ")");
    for (var i = 0; i < count; i++) {
        var product = products[i];
        if (Settings.getPlatform() != "mobileweb") {
            // native app Query.search returns only "id, firstcolumn"
            product = Query.selectId("products", products[i].id);
        }
        _writeProduct(product);
    }
    return count;
}

//////////////////////////////
var _orderBy = "introdate DESC";
var _orderByLabel; // initialized in main

function viewProducts() {
    Toolbar.setTitle("SONY"); //R.PRODUCTS2;

    if (Settings.getPlatform() != "mobileweb") Toolbar.addButton("Search", "search('')", "search");

    var code = Settings.get("country");
    if (Settings.isTablet() == false) {
        Toolbar.addTab(R.PRODUCTS2, "");
        Toolbar.addTab(R.PROMOTIONS, "viewPromotions()");
        Toolbar.addTab(R.STORES, "viewStoreLocator()");
    }

    var groups = Query.select("groups", "id;name;thumbnail", null, "rank");
    for (var i = 0; i < groups.length; i++) {
        var group = groups[i];
        List.addItem(group.name, "viewGroup({group.id})", "class:category;img:" + group.thumbnail);

        if (i == 3) _addProjectorGroup(code);
    }
    var style = Settings.isTablet() ? "grid" : "list";
    List.show(style);
    LeftPane.write();
    App.track("/products");
}

function viewGroup(groupid) {
    var visibleCategories = new Array();

    var group = Query.selectId("groups", groupid);
    var categories = Query.select("categories", "id;name;thumbnail", "parentid={groupid}", "rank");
    for (var i = 0; i < categories.length; i++) {
        var category = categories[i];
        var count = Query.count("products", "parentid='' AND categoryid CONTAINS {category.id}");
        if (count > 0) visibleCategories.push(category);
    }

    if (visibleCategories.length == 1) {
        viewCategory(visibleCategories[0].id);
        return;
    }

    for (var i = 0; i < visibleCategories.length; i++) {
        var category = visibleCategories[i];
        if (Settings.get("country") == "in") {
            writeIndiaSmartPhoneCategory(category);
        } else {
            List.addItem(category.name, "viewCategory({category.id})", "class:category;img:" + category.thumbnail);
        }
    }
    List.show();
    LeftPane.write();
}

function writeIndiaSmartPhoneCategory(category) {
    if (category.name == "Xperia™ Smartphones") {
        List.addItem(category.name, "App.web('http://www.sonymobile.com/in/products/phones/')", "class:category;img:" + category.thumbnail);
    } else if (category.name == "Mobile Phone Accessories") {
        List.addItem(category.name, "App.web('http://www.sonymobile.com/in/products/accessories/')", "class:category;img:" + category.thumbnail);
    } else if (category.name == "SmartWear") {
        List.addItem(category.name, "App.web('http://www.sonymobile.com/in/products/smartwear/')", "class:category;img:" + category.thumbnail);
    } else {
        List.addItem(category.name, "viewCategory({category.id})", "class:category;img:" + category.thumbnail);
    }
}

function _addProjectorGroup(code) {
    var url;

    if (code == "sg" || code == "my" || code == "th" || code == "id") {
        url = "http://pro.sony-asia.com/productcategory/prof-bc-proj-projector";
        var platform = Settings.getPlatform();
        if (platform != 'mobileweb') url += '?hpid=native:' + platform + ':' + code + ':categorylist';
    } else {
        return;
    }
    var img = "http://www.sony-asia.com/corporate/resources/en_AP/images/toppage/sitehomebanner/products/Projector.jpg";
    List.addItem(R.PROJECTORS, "App.web({url})", "class:category;img:" + img);
}

function viewCategory(id, seriesid) {
    var category = Query.selectId("categories", id);
    if (category.imgurl != '') List.addImage(category.imgurl);
    //if (category.description != '') List.addItem(R.WHYSONY, "viewWhySony({category.id})");

    var where = "categoryid CONTAINS {id} AND parentid=''";

    if (seriesid == null) seriesid = ''; // All Series
    if (seriesid != '') where += ' AND seriesid={seriesid}';

    if (Settings.getPlatform() == "mobileweb") {
        var country = Settings.get("country");
        if (!(country == 'me-en' || country == 'me-ar' || country == 'af-en' || country == 'af-fr' || country == 'at-pt' || country == 'ir'))
            List.addButton(R.SORTBY, "showSortBy({category.hasSeries}, {id})");
        else if (category.hasSeries) {
            List.addButton(R.SORTBY, "onSeries({id})"); // No prices for ME, so no sort by price, we display Series selection directly
        }
    } else {
        Toolbar.addButton(R.SORTBY, "showSortBy({category.hasSeries}, {id})", "sortby");
    }

    var galleryCount = Query.count("assetgroups", "categoryid CONTAINS {id}");
    if (galleryCount > 0) List.addButton(R.SAMPLEPHOTOS, "viewAssetGroup({id})", "icon=arrow;class=black");
    Toolbar.setStyle("search");

    _computeAccessories();
    var accessories = _accessories[id];
    if (accessories != null) List.addButton(R.ACCESSORIES, "showAccessories({category.id})");
    if (_orderByLabel == null) _orderByLabel = R.LATEST;

    if (seriesid != '') {
        var serie = Query.selectId("series", seriesid);
        List.addHeader(category.name + " - " + serie.name);
    } else {
        List.addHeader(category.name + " - " + _orderByLabel);
    }
    _writeProductList(where);
    List.show();
    LeftPane.write();
    App.track("/productcategory/" + encodeURIComponent(category.name));
}

var _accessories = null; // map of accessories by categoryid

function _computeAccessories() {
    // already computed?
    if (_accessories != null) return;
    _accessories = new Array();

    // 1. Create a product category Hashtable
    var productCategoryMap = new Array();
    var products = Query.select("products", "id;categoryid", "parentid=''");
    for (var i = 0; i < products.length; i++) {
        var product = products[i];
        productCategoryMap[product.id] = product.categoryid;
    }

    // for each accessory, get its first parent categoryid and add it to the list if is it the requested category
    var accessories = Query.select("products", "id;name;thumbnail;price;currency;code;parentid", "parentid!=''", "introdate DESC");
    for (var i = 0; i < accessories.length; i++) {
        var accessory = accessories[i];

        var accessoryCategoryMap = new Array();
        var parents = accessory.parentid.split("|");
        for (var j = 0; j < parents.length; j++) {
            var parentid = parents[j];
            var parentCategoryid = productCategoryMap[parentid];
            if (accessoryCategoryMap[parentCategoryid] == null) {
                if (_accessories[parentCategoryid] == null) _accessories[parentCategoryid] = new Array();
                _accessories[parentCategoryid].push(accessory);

                accessoryCategoryMap[parentCategoryid] = "1";
            }
        }
    }
}

function showAccessories(categoryid) {
    _computeAccessories();

    Toolbar.setStyle("search");
    var items = _accessories[categoryid];
    for (var i = 0; i < items.length; i++) {
        _writeProduct(items[i]);
    }
    List.show();
}

function showSortBy(hasSeries, categoryid) {
    var country = Settings.get("country");
    List.addItem(R.LATEST, "onLatest()");
    if (hasSeries != 0) Popup.add(R.SERIES, "onSeries({categoryid})");
    Popup.add(R.PRICE, "onPrice()");
    Popup.show();
}

function onLatest() {
    _orderBy = "introdate DESC";
    _orderByLabel = R.LATEST;
    History.reload();
}

function onPopular() {
    _orderBy = "rating DESC";
    _orderByLabel = R.POPULAR;
    History.reload();
}

function onPrice() {
    _orderBy = "price";
    _orderByLabel = R.PRICE;
    History.reload();
}

// seriesid = currently selected series id. If all, seriesid=''
function onSeries(categoryid) {
    // display list of series of categoryid and containing at least one product
    var series = Query.select("series", "id;name", "categoryid={categoryid}", "name");

    if (series.length == 0) { App.alert("No series"); return; }
    series.unshift({ name: R.ALLSERIES, id: '' });
    //List.addItem(R.ALLSERIES, "viewCategory({categoryid}, '')");

    for (var i = 0; i < series.length; i++) {
        var serie = series[i];
        var id = serie.id;
        var count = Query.count("products", "seriesid={id}");
        var func = "viewCategory({categoryid}, {id})";
        var onclick = "History.reload({func})";
        if (count > 0) List.addItem(serie.name, onclick);
    }
    List.show("popup");
}

function _writeProductList(where, header) {
    var products = Query.select("products", "id;name;thumbnail;price;currency;code;introdate", where, _orderBy);
    if (products.length == 0) return;
    if (header != null) List.addHeader(header);
    var count = products.length;
    for (var i = 0; i < count; i++) {
        _writeProduct(products[i]);
    }
}

function _writeProduct(product) {
    var subtitle = product.name;
    if (product.price > 0 && product.introdate <= today()) {
        var price = Format.price(product.price, product.currency, 0);
        if (Settings.getPlatform() == "mobileweb") subtitle += " <div class=price>" + price + "</div>";
        else subtitle += " " + price;
    }
    var style = "img:" + product.thumbnail;
    if (product.introdate > today()) style += ";tag:" + R.COMINGSOON;
    else if (product.introdate > today() - 30 * DAY) style += ";tag:" + R.NEW;
    List.addItemSubtitle(product.code, subtitle, "viewProduct({product.id})", style);
}

// color is optional - used to display secondary color
function viewProduct(id, color) {
    var product = Query.selectId("products", id);
    var firstProductImageUrl = null;

    if (color == null) { // get the image from product main color
        firstProductImageUrl = getFirstProductImageUrl(id, '');
    } else {
        firstProductImageUrl = getFirstProductImageUrl(id, color);
        // case where viewproduct is actually called with main color - in DB the color field = '' for main color
        if (firstProductImageUrl == null) firstProductImageUrl = getFirstProductImageUrl(id, '');
    }

    var reviewCount = Query.count("reviews", "productid={id}");
    var galleryCount = Query.count("assetgroups", "categoryid CONTAINS {product.categoryid}");
    var videoCount = Query.count("videos", "productid CONTAINS {id}");
    var promo = _getProductPromotion(product.promotionid);
    var productUrl = product.url.toLowerCase(); // Facebook & Twitter are Case Sensitive URL...

    //Toolbar.setTitle(""/*R.PRODDETAILS*/);
    Toolbar.setTitle(product.code);

    if (firstProductImageUrl != null) List.addImage(firstProductImageUrl, "viewGallery({id})", "height=180px;class=productimage;scale=center");

    if (Settings.getPlatform() == "mobileweb") {
        //List.addItemLabel(product.code, product.name, null, "class=productcode");
        var style = "";
        if (product.introdate > today()) style = "tag:" + R.COMINGSOON;
        else if (product.introdate > today() - 30 * DAY) style = "tag:" + R.NEW;
        List.addItemSubtitle(product.code, product.name, "viewProduct({product.id})", style);
    } else {
        List.addItemLabel(product.code, product.name);
    }
    var price = "";
    if (product.price > 0 && product.introdate <= today()) price = Format.price(product.price, product.currency, 0);
    if (price != "" || product.rating > 0) List.addItemRating(price, product.rating, null, "class=productrating");
    if (product.colors != '') List.addItemColor(R.AVAILABLEIN, product.colors, "showColorPicker({id}, {product.colors})");

    var description = product.shortdescription;
    List.addItemLabel("", description, null, "class=productdesc");

    if (Settings.getPlatform() == "mobileweb") {
        List.addItemShare(productUrl);
        List.addItemLabel("", "<div class=pricedisclaimer>" + (price != '' ? R.PRICE_DISCLAIMER : R.PRICE_DISCLAIMER2) + "</div>");
    } else {
        Toolbar.addButton(R.SHARE, "App.share({product.url})", "share");
        if (Wishlist.contains(product.id) == false) {
            Toolbar.addButton(R.WISHLIST, "Wishlist.add({product.id})", "star");
        } else {
            Toolbar.addButton(R.WISHLIST, "Wishlist.remove({product.id})", "favorite");
        }
    }

    writeVideoSection("productid CONTAINS {id}", R.VIDEOS);
    writeTechnologySection("id IN " + list(product.promotionid), R.TECHNOLOGY);

    if (Settings.isTablet() == false) {
        if (Settings.getPlatform() == "mobileweb") {
            List.addItem(R.SPECS, "viewSpec({id})", "icon=arrow;class=black");
            List.addItem(R.PHOTOGALLERY, "viewGallery({id})", "icon=arrow;class=black");
        }
        if (galleryCount > 0) List.addItem(R.SAMPLEPHOTOS, "viewAssetGroup({product.categoryid})", "icon=arrow;class=black");
        if (promo != null) List.addItem(R.PROMOTION, "viewPromotion({promo.id})", "icon=arrow;class=black");
        if (reviewCount > 0) List.addItem(R.REVIEWS, "viewReviews({id})", "icon=arrow;class=black");
        if (product.parentid != '') {
            List.addItem(R.COMPATIBILITY, "viewCompatibility({product.parentid})", "icon=arrow;class=black");
        } else {
            var accessoriesCount = Query.count("products", "parentid CONTAINS {id}");
            if (accessoriesCount > 0) List.addItem(R.ACCESSORIES, "viewAccessories({id})", "icon=arrow;class=black");
        }
        List.addItem(R.WHERETOBUY, "viewStoreLocatorForCategory({product.categoryid})", "icon=arrow;class=black");

        var country = Settings.get("country");
        buyLabel = (country == "au" || country == "nz") ? R.BUYNOW : R.VIEWINFULLSITE;
        var urlfullSite = productUrl + "?m=0";
        List.addItem(buyLabel, "App.web({urlfullSite})", "icon=arrow;class=black");
    }
    
    // For NFC
    //var funcCall = "v({id})";
    //Toolbar.addButton("Write NFC Tag", "App.writeNfc({funcCall})");
    //var func = "Sony.viewProduct({id})";
    //var func2 = "App.notify({id},'New Sony Product',{product.name},{func},'')";
    //Toolbar.addButton("Push Notification", func2);

    Toolbar.addTab("Info", "");
    Toolbar.addTab("Spec", "viewSpec({id})");
    Toolbar.addTab("Photos", "viewGallery({id})");
    
    List.show("form");
    LeftPane.writeProduct(id);
    App.track("/product/" + encodeURIComponent(product.code));
}

function getProductImages(productid, color) {

    var images = Query.select("productimages", "rank;color;imgurl", "productid={productid} AND color={color}", "rank");

/*    images.sort(function (o1, o2) {
        var r1 = Number(o1.rank);
        var r2 = Number(o2.rank);
        if (r1 < r2)
            return -1;
        else if (r1 == r2)
            return 0;
        else
            return 1;
    });
    */

    var imageUrls = [];
    for (var i = 0; i < images.length; i++) {
        var item = images[i];
        if (item.color == null) item.color = ''; // for optimization purposes, the RSS query does not return fields when they are empty!
        if (item.color == color) imageUrls.push(item.imgurl);
    }
    return imageUrls;
}

function getFirstProductImageUrl(productid, color) {
    var firstImageUrl = null;
    var imageUrls = getProductImages(productid, color);
    if (imageUrls.length > 0) firstImageUrl = imageUrls[0];
    return firstImageUrl;
}

function showColorPicker(productid, productcolors) {
    var colors = productcolors.split("|");
    if (colors.length <= 1) return;
    for (var i = 0; i < colors.length; i++) {
        var color = colors[i];
        var onclick = "viewProduct({productid},{color})";
        List.addItemColor("", color, "History.reload({onclick})");
    }
    var style = (Settings.getPlatform() == 'iphone')?"form":"popup";
    List.show(style);
}

function _getProductPromotion(promotionid) {
    if (promotionid == '') return null;
    var parts = promotionid.split("|");
    for (var i = 0; i < parts.length; i++) {
        var promo = Query.selectId("promotions", parts[i]);
        if (promo != null) {
            if (promo.type == 3 || (promo.type == 0 && promo.startdate <= today() && promo.enddate >= today())) {
                return promo;
            }
        }
    }
    return null;
}

function viewAccessories(productid) {
    var where = "parentid CONTAINS {productid}";
    _writeProductList(where);
    List.show();
    LeftPane.writeProduct(productid);
}

function viewCompatibility(parentid) {
    var where = "id IN " + list(parentid);
    _writeProductList(where);
    List.show();
    LeftPane.writeProduct(parentid);
}

function viewGallery(productid) {
    var urls = getProductImages(productid, '');
    var buf = [];
    for (var i = 0; i < urls.length; i++) {
        buf.push(urls[i]);
    }

    var product = Query.selectId("products", productid);

    Toolbar.setTitle(product.code);
    Toolbar.addTab("Info", "viewProduct({productid})");
    Toolbar.addTab("Spec", "viewSpec({productid})");
    Toolbar.addTab("Photos", "");

    WebView.showImage(buf.join("|"));
    LeftPane.writeProduct(productid);
}

///// Reviews
function viewReviews(productid) {
    var reviews = Query.select("reviews", "id;name;author;date;rating;description", "productid={productid}", "date DESC");
    for (var i = 0; i < reviews.length; i++) {
        var review = reviews[i];
        var header = review.name;
        if (header.length > 0) header += " - ";
        header += Format.date(review.date);
        List.addHeader(header);
        var description = review.description;
        if (Settings.getPlatform() != "mobileweb") {
            var item = Query.selectId("reviews", review.id);
            description = item.description;
        }
        List.addItemLabel(" " + R.BY + " " + review.author, description);
        List.addItemRating("", review.rating);
    }
    List.show();
    LeftPane.writeProduct(productid);
}

///////////////////////

function viewVideos() {
    Toolbar.setTitle(R.VIDEOS);
    var categories = Query.select("videocategories", "id;name", null, "name");
    for (var i = 0; i < categories.length; i++) {
        var category = categories[i];
        List.addItem(category.name, "viewVideoList({category.id})");
    }
    List.show();
    App.track("/videos");
}

function viewVideoList(categoryid) {
    var category = Query.selectId("videocategories", categoryid);
    if (category.url != '') {
        WebRequest.get('http://sony.upvise.com/uws/sony/', 'youtube=1&url=' + category.url, "onVideoList");
    } else {
        writeVideoSection("categoryid={categoryid}");
        List.show();
    }
}

function onVideoList(videos) {
    if (videos == null) return;
    for (var i = 0; i < videos.items.length; i++) {
        var snippet = videos.items[i].snippet;
        List.addItem(snippet.title, "App.video({snippet.resourceId.videoId})", "img:" + snippet.thumbnails.default.url);
    }
    List.show();
}

function writeVideoSection(where, title) {
    var videos = Query.select("videos", "name;url", where);
    if (title != null && videos.length > 0) List.addHeader(title);
    for (var i = 0; i < videos.length; i++) {
        var video = videos[i];
        var img = "http://i3.ytimg.com/vi/" + video.url + "/default.jpg";
        List.addItem(video.name, "App.video({video.url})", "img:" + img);
    }
}

function viewNews() {
    Toolbar.setTitle(R.NEWS);
    var news = Query.select("promotions", "id;name;startdate;imgurl", "type=4", "startdate DESC");
    for (var i = 0; i < news.length; i++) {
        var item = news[i];
        var style = (item.imgurl != '') ? "img:" + item.imgurl : null;
        var name = item.name;
        if (Settings.getPlatform() != "mobileweb") name = Format.text(name);
        List.addItemSubtitle(name, Format.date(item.startdate), "viewNewsDetail({item.id})", style);
    }
    List.show();
    App.track("/news");
}

function viewNewsDetail(id) {
    var news = Query.selectId("promotions", id);
    Toolbar.setTitle(R.NEWS);
    Toolbar.setStyle("nextprevious");
    List.addImage(news.imgurl);
    var name = news.name;
    if (Settings.getPlatform() != "mobileweb") name = Format.text(name);
    List.addItem(name);
    var label = "";
    if (news.startdate > 0) label = Format.date(news.startdate);
    List.addItemLabel(label, news.description);
    if (news.url != '') List.addItem(R.MOREINFO, "App.web({news.url})", "icon=arrow");
    var where = "promotionid CONTAINS {id}";
    _writeProductList(where, R.APPLICABLEPRODUCTS);
    List.show("form");
}

function viewSpec(productid) {
    var baseUrl = "http://sony.upvise.com/uws/user/";
    var specs = Query.rss(baseUrl + "sony.store.specs?productid=" + encodeURIComponent(productid));
    for (var i = 0; i < specs.items.length; i++) {
        var spec = specs.items[i];
        if (spec.type == 0) List.addHeader(spec.label);
        else List.addItemLabel(spec.label, spec.value);
    }
    Toolbar.setStyle("search");
    var product = Query.selectId("products", productid);
    Toolbar.setTitle(product.code);
    Toolbar.addTab("Info", "viewProduct({productid})");
    Toolbar.addTab("Spec", "");
    Toolbar.addTab("Photos", "viewGallery({productid})");
  
    List.show();
    LeftPane.writeProduct(productid);
}

function viewTechnologies() {
    Toolbar.setTitle(R.TECHNOLOGY);
    writeTechnologySection();
    List.show();
    LeftPane.write();
    App.track("/technology");
}

function writeTechnologySection(where, title) {
    var where2 = "type=1";
    if (where != null) where2 += " AND " + where;
    var items = Query.select("promotions", "id;name;description;imgurl", where2, "startdate");
    if (items.length > 0 && title != null) List.addHeader(title);
    for (var i = 0; i < items.length; i++) {
        var item = items[i];
        var name = item.name;
        if (Settings.getPlatform() != "mobileweb") name = Format.text(name);
        List.addItem(name, "viewTechnology({item.id})", "img:" + item.imgurl);
    }
}

function viewTechnology(id) {
    var promo = Query.selectId("promotions", id);
    Toolbar.setTitle(R.TECHNOLOGYDETAILS);
    //Toolbar.setStyle("nextprevious");
    List.addHeader(promo.name);
    if (promo.imgurl != '') List.addImage(promo.imgurl);
    List.addItemLabel("", promo.description);
    if (promo.url != '') List.addItem(R.MOREINFO, "App.web({promo.url})", "icon=arrow;class=black");

    var where = "promotionid CONTAINS {id}";
    _writeProductList(where, R.PRODUCTS2);
    List.show("form");
    LeftPane.write();
    App.track("/technology/" + encodeURIComponent(promo.name));
}

////////////////////////////// Promotions

function viewPromotions() {
    Toolbar.setTitle("SONY"/*R.PROMOTIONS*/);
    if (Settings.getPlatform() != "mobileweb") Toolbar.addButton("Search", "search('')", "search");
    if (Settings.isTablet() == false) {
        Toolbar.addTab(R.PRODUCTS2, "viewProducts()");
        Toolbar.addTab(R.PROMOTIONS, "");
        Toolbar.addTab(R.STORES, "viewStoreLocator()");
    }

    // We order RSS promos by rank in RSS feed, i.e startdate
    // And we order manually entered promos by start date DESC
    var rsspromos = Query.select("promotions", "id;name;imgurl;startdate;enddate", "type=0 AND startdate<100", "startdate");
    var promos = Query.select("promotions", "id;name;imgurl;startdate;enddate", "type=0 AND startdate<={today()} AND enddate>={today()}", "startdate DESC");
    var stores = Query.select("stores", "id;name;promourl", "promourl!='' AND startdate<={today()} AND enddate>={today()}", "startdate DESC");
    var gifts = Query.select("promotions", "id;name;imgurl", "type=3 AND startdate<={today()} AND enddate>={today()}", "startdate DESC");
    viewPromoList(promos);
    viewPromoList(rsspromos);
    List.addHeader(R.STOREPROMO);
    for (var i = 0; i < stores.length; i++) {
        var store = stores[i];
        var subtitle = Format.date(store.startdate) + " - " + store.date(promo.enddate);
        List.addItemSubtitle(store.name, subtitle, "viewStore({store.id})", "img:" + store.promourl);
    }
    List.addHeader((Settings.get("country") == 'nz') ? "New Releases" : R.GIFTIDEAS);
    for (var i = 0; i < gifts.length; i++) {
        var gift = gifts[i];
        List.addItem(gift.name, "viewPromotion({gift.id})", "img:" + gift.imgurl);
    }
    List.show();
    LeftPane.write();
    App.track("/promotions");
}

function viewPromoList(promos) {
    for (var i = 0; i < promos.length; i++) {
        var promo = promos[i];
        var name = promo.name;
        if (Settings.getPlatform() != "mobileweb") name = Format.text(name);
        if (promo.startdate != 0 && promo.enddate != 0) {
            if (promo.startdate <= today() && promo.enddate >= today()) {
                var subtitle = Format.date(promo.startdate) + " - " + Format.date(promo.enddate);
                List.addItemSubtitle(name, subtitle, "viewPromotion({promo.id})", "img:" + promo.imgurl);
            }
        } else {
            List.addItem(name, "viewPromotion({promo.id})", "img:" + promo.imgurl);
        }
    }
}

function viewPromotion(id) {
    var promo = Query.selectId("promotions", id);
    if (promo.imgurl != '') List.addImage(promo.imgurl);
    var subtitle = "";
    if (promo.type == 0 && promo.startdate!=0 && promo.enddate!=0) subtitle = Format.date(promo.startdate) + " - " + Format.date(promo.enddate);

    if (Settings.getPlatform() == "mobileweb") {
        if (subtitle != "")
            List.addItemSubtitle(promo.name, subtitle);
        else
            List.addItem(promo.name);
    } else {
        Toolbar.setTitle(Format.text(promo.name));
        if (subtitle != "") List.addItem(subtitle);
    }
    
    List.addItemLabel("", promo.description);
    if (promo.url != '') {
        List.addItem(R.MOREINFO, "App.web({promo.url})", "icon=arrow;class=black");

        if (Settings.getPlatform() == "mobileweb") {
            List.addItemShare(promo.url);
        } /*else if (Settings.isTablet() == false) {
            List.addButton(R.SHARE, "App.share({promo.url})");
        } */else {
            Toolbar.addButton(R.SHARE, "App.share({promo.url})", "share");
        }
    }
    _writeProductList("promotionid CONTAINS {id}", R.APPLICABLEPRODUCTS);

    List.show("form");
    LeftPane.write();
    App.track("/promotion/" + encodeURIComponent(promo.name));
}

////////// Store Locator

function viewStoreLocator() {
    var country = Settings.get("country");
    if (country == 'vn') {
        App.web('http://shop.sony.com.vn/');
        return;
    }

    Toolbar.setTitle("SONY"/*R.STORELOCATOR*/);
    if (Settings.getPlatform() != "mobileweb") Toolbar.addButton("Search", "search('')", "search");
    if (Settings.isTablet() == false) {
        Toolbar.addTab(R.PRODUCTS2, "viewProducts()");
        Toolbar.addTab(R.PROMOTIONS, "viewPromotions()");
        Toolbar.addTab(R.STORES, "");
    }

    var count = Query.count("stores", "type<3 AND categoryid!=''");

    List.addButton(R.SEARCHNAME, "searchStore()");
    var label = R.SEARCHSTATE;
    
    if (country == "sg")
        label = R.SEARCHZONE;
    else if (country == "nz")
        label = R.SEARCHREGION;
    else if (country.substring(0, 2) == 'me' || country.substring(0, 2) == 'af' || country == "at-pt")
        label = R.SEARCHCOUNTRY;
    var where = 'type<3'; // stores, not service center
    List.addButton(label, "viewZoneList({where})");
    if (Settings.getPlatform() != "mobileweb") List.addButton(R.NEARESTSTORES, "viewNearestStoreList({where})");
    if (count > 0) List.addButton(R.BYPRODUCTCATEGORY, "viewProductCategoryStoreList({where})");
    List.show("form");
    App.track("/storelocator");
}

function viewStoreLocatorForCategory(categoryid) {
    var where = "categoryid CONTAINS {categoryid}";
    var count = Query.count("stores", where);
    if (count > 0) {
        viewZoneList(where);
    } else {
        viewStoreLocator();
    }
}

function searchStore() {
    if (Settings.getPlatform() == "mobileweb") {
        _searchStoreOnly = true;
        showSearch();
    } else {
        var str = App.prompt(R.ENTERSTORE, '', "search");
        if (str == null) History.reload();
        else History.replace("onStoreSearch({str})");
    }
}

function onStoreSearch(str) {
    writeStoreSearchSection(str, "type!=3", R.STORES); // not service center
    List.show();
}

function writeStoreSearchSection(search, where, title) {
    var stores = Query.search("stores", search, "name;address", where);
    // TODO sort by type ascending for Sony Store first....
    var count = Math.min(stores.length, 20);
    if (count > 0) List.addHeader(title + " (" + count + ")");
    for (var i = 0; i < count; i++) {
        var store = stores[i];
        if (Settings.getPlatform() != "mobileweb") store = Query.selectId("stores", store.id);
        List.addItemSubtitle(store.name, store.address, "viewStore({store.id})")
    }
    return count;
}

function viewStoreList(where) {
    viewStoreBuildList(where);
    List.show();
}

function viewStoreBuildList(where) {
    if (where.indexOf("type=3") != -1) {
        var serviceShops = Query.select("stores", "id;name;address;promourl", where, "name");
        for (var i = 0; i < serviceShops.length; i++) {
            var shop = serviceShops[i];
            List.addItemSubtitle(shop.name, shop.address, "viewStore({shop.id})");
        }
    } else {
        if (Settings.get("country") == "th") {
            var sonystores = Query.select("stores", "id;name;address;promourl", "type=0 AND " + where, "name");
            var sonycenters = Query.select("stores", "id;name;address;promourl", "type=1 AND " + where, "name");
            var vaiostars = Query.select("stores", "id;name;address;promourl", "type=2 AND " + where, "name");
            viewStoreListSection(sonystores, "โซนี่ สโตร์");
            viewStoreListSection(sonycenters, "โซนี่ เซ็นเตอร์");
            viewStoreListSection(vaiostars, "ไวโอ้ สตาร์");
        } else {
            var sonyShops = Query.select("stores", "id;name;address;promourl", "type<2 AND " + where, "name");
            var otherShops = Query.select("stores", "id;name;address;promourl", "type=2 AND " + where, "name");
            viewStoreListSection(sonyShops, R.SONYSHOPS);
            viewStoreListSection(otherShops, R.DEALERS);
        }
    }
}

function viewStoreListSection(stores, header) {
    if (stores.length > 0) List.addHeader(header);
    for (var i = 0; i < stores.length; i++) {
        var store = stores[i];
        List.addItemSubtitle(store.name, store.address, "viewStore({store.id})");
    }
}

function viewZoneList(where) {
    var zones = Query.select("zones", "id;name", null, "name");
    var citiesCount = Query.count("cities");

    var shops = Query.select("stores", "zoneid", where);
    var counter = _groupcount(shops, "zoneid");
    for (var i = 0; i < zones.length; i++) {
        var zone = zones[i];
        var where2 = where + " AND zoneid={zone.id}";
        var onclick = citiesCount > 0 ? "viewCityList({where},{zone.id})" : "viewStoreList({where2})";
        var count = counter[zone.id];
        if (count != null) List.addItem(zone.name, onclick, "number=" + count);
    }
    List.show();
}

function viewCityList(where, zoneid) {
    var cities = Query.select("cities", "id;name", "zoneid={zoneid}", "name");
    var shops = Query.select("stores", "cityid", where);
    var counter = _groupcount(shops, "cityid");
    for (var i = 0; i < cities.length; i++) {
        var city = cities[i];
        var count = counter[city.id];
        var where2 = where + " AND cityid={city.id}";
        if (count > 0) List.addItem(city.name, "viewStoreList({where2})", "number=" + count);
    }

    // also display all stores for zoneid where city=''
    var shops = Query.select("stores", "id;name;address", where + " AND zoneid={zoneid} AND cityid=''", "name");
    for (var i = 0; i < shops.length; i++) {
        var shop = shops[i];
        List.addItemSubtitle(shop.name, shop.address, "viewStore({shop.id})");
    }

    List.show();
}

function viewNearestStoreList(where, tab) {
    var geo = Settings.getLocation();
    var stores = Query.select("stores", "id;name;geo", where + " AND geo!=''");
    for (var i = 0; i < stores.length; i++) {
        var store = stores[i];
        store.distance = Settings.getDistanceTo(geo, store.geo);
    }
    stores.sort(function (o1, o2) {
        return o1.distance - o2.distance;
    });

    if (tab == null) tab = 0;
    Toolbar.addTab("List", tab == 0 ? "" : "viewNearestStoreList({where},0)");
    Toolbar.addTab("Map", tab == 1 ? "" : "viewNearestStoreList({where},1)");
    var count = Math.min(20, stores.length);

    if (tab == 0) {
        for (var i = 0; i < count; i++) {
            var store = stores[i];
            //if (item.distance > 100 * 1000) break; // no more than 100km
            List.addItemSubtitle(store.name, Format.distance(store.distance), "viewStore({store.id})");
        }
        List.show();
    } else {
        for (var i = 0; i < count; i++) {
            var store = stores[i];
            List.addItemLabel(store.name, store.geo, "viewStore({store.id})");
        }
        List.show("map");
    }
}

function viewProductCategoryStoreList(where) {
    var categories = Query.select("categories", "id;name;thumbnail", null, "name");
    for (var i = 0; i < categories.length; i++) {
        var category = categories[i];
        var where2 = where + " AND categoryid CONTAINS {category.id}";
        var count = Query.count("stores", where2);
        if (count > 0) List.addItem(category.name, "viewZoneList({where2})", "class:category;img:" + category.thumbnail);
    }
    List.show();
}

function viewStore(id) {
    var store = Query.selectId("stores", id);
    var title = (store.type == 3) ? R.SERVICECENTERDETAILS : R.STOREDETAILS;
    if (store.promourl != '' && store.startdate <= today() && store.enddate >= today()) List.addImage(store.promourl);
    if (Settings.getPlatform() == "mobileweb") {
        List.addItem(store.name);
    } else {
        Toolbar.setTitle("");
        List.addItemTitle(store.name, null, null, "text-align:center");
    }
    if (store.promourl != '') List.addItemLabel(R.PROMODATE, Format.date(store.startdate) + " " + R.TO + " " + Format.date(store.enddate));
    List.addItemLabel(R.HOURS, store.businesshours);
    List.addItemLabel(R.ADDRESS, store.address);
    List.addButton(R.VIEWMAP, "App.map({store.name},{store.geo})");
    List.addButton(R.CALLNOW, "App.call({store.phone})");

    if (store.categoryid != null && store.categoryid != "") {
        List.addHeader(R.PRODUCTCATEGORIES);
        var categories = Query.select("categories", "id;name;thumbnail", "id IN " + list(store.categoryid), "rank");
        for (var i = 0; i < categories.length; i++) {
            var category = categories[i];
            var count = Query.count("products", "parentid='' AND categoryid CONTAINS {category.id}");
            if (count > 0) List.addItem(category.name, "viewCategory({category.id})", "class:category;img:" + category.thumbnail);
        }
    }
    List.show("form");
}

//////////////////// Support
function viewSupport() {
    Toolbar.setTitle(R.SUPPORT);

    var imgurl = null;
    var onclick = null;
    var country = Settings.get("country");
    if (country == "sg") {
        imgurl = "http://www.sony.com.sg/microsite/support/images/mobile_wty_1280x300.jpg";
        onclick = "App.web('https://www.sony.com.sg/registerproduct?hpid=registerproduct:mobileapp:support:banner&m=0')";
    } else if (country == "af-en" || country == "me-en") {
        imgurl = "http://www.sony-mea.com/microsite/mobile/hdr-mobile.jpg";
    } else if (country == "at-pt") {
        imgurl = "http://www.sony-mea.com/microsite/mobile/mcf-sup-pt.jpg";
    } else if (country == "af-fr") {
        imgurl = "http://www.sony-mea.com/microsite/mobile/mcf-sup-fr.jpg";
    } else if (country == "me-ar") {
        imgurl = "http://www.sony-mea.com/microsite/mobile/mcf-sup-ar.jpg";
    } else if (country == "in") {
        imgurl = "img/Live-Chat-Banner-1200x400.jpg";
        onclick = "App.web('https://www.sony.co.in/webchatform')";
    }
    if (imgurl != null) List.addImage(imgurl, onclick);

    if (country.substring(0, 2) == "af" || country.substring(0, 2) == "me" || country == "at-pt") {
        List.addHeader(R.CUSTCONTACTCENTER);
    } else {
        List.addHeader(R.CUSTINFOCENTER);
    }
    if (country == "in") {
        List.addButton(R.CALLSONY + " (All Products)", "App.call('1800-103-7799')");
    } else if (country == "nz") {
        List.addButton(R.CALLSONY + " (" + R.MOBILEPHONES + ")", "App.call('0800 100 150')");
        List.addButton(R.CALLSONY + " (" + "Playstation" + ")", "App.call('09 415 2447')");
        List.addButton(R.CALLSONY + " (" + R.OTHERPRODUCTS + ")", "App.call('0800 766 969')");
    } else if (country == "za") {
        List.addButton(R.CALLSONY + " (" + R.VAIOREPAIRLINE + ")", "App.call('0861 777 002')");
        List.addButton(R.CALLSONY + " (" + R.MOBILEPRODUCTS + ")", "App.call('0861 632222')");
        List.addButton(R.CALLSONY + " (" + "Playstation" + ")", "App.call('086 1773 783')");
        List.addButton(R.CALLSONY + " (" + R.OTHERPRODUCTS + ")", "App.call('011 690 3555')");
    } else if (country.substring(0, 2) == "af" || country.substring(0, 2) == "me" || country == "at-pt") {
        List.addButton(R.UAETOLLFREE, "App.call('+971 800 7669')");
        List.addButton(R.ALLOTHERCOUNTRIES, "App.call('+971 800 7669')");
    } else {
        var number = Settings.get("supportphone");
        if (number != "") List.addButton(R.CALLSONY, "App.call({number})");
    }

    List.addHeader(R.SERVICECENTERS);
    var where = "type=3"; // service center
    var count = Query.count("stores", "type=3");
    if (count < 10) {
        viewStoreBuildList(where);
    } else {
        var label = R.SEARCHSTATE;
        if (country == "sg") {
            label = R.SEARCHZONE;
        } else if (country == "nz") {
            label = R.SEARCHREGION;
        } else if (country.substring(0, 2) == 'me' || country.substring(0, 2) == 'af' || country == "at-pt") {
            label = R.SEARCHCOUNTRY;
        }
        if (country == "vn")
            List.addButton(label, "App.web('http://ttbh.sony.com.vn')");
        else
            List.addButton(label, "viewZoneList({where})");
        if (Settings.getPlatform() != "mobileweb") List.addButton(R.NEARESTSERVICECENTERS, "viewNearestStoreList({where})");
        var count = Query.count("stores", "type=3 AND categoryid!=''");
        if (count > 0) List.addButton(R.BYPRODUCTCATEGORY, "viewProductCategoryStoreList({where})");
    }
    List.addHeader(R.GETONLINESUPPORT);
    List.addItem(R.SUPPORTSUBTITLE);
    var supportSiteUrl = getSupportSiteUrl(country);
    var title = (country == "au" || country == "nz" || country == "in" || country == "sg") ? "Access Support Site" : R.VIEWINFULLSITE;
    List.addButton(title, "App.web({supportSiteUrl})");
    
    List.show("form");

    App.track("/support");
}

function getSupportSiteUrl(country) {

    if (country == "au" || country == "nz" || country == "in" || country == "sg") return _fullSiteUrl.replace('http://www', 'http://m') + "/support";
  
    var urlfullSite = "";
    var pos = _fullSiteUrl.indexOf("/section");
    if (pos == -1) {
        urlfullSite = _fullSiteUrl + "/section/support?m=0";
    } else {
        var offsetStr = "/section/home?";
        urlfullSite = _fullSiteUrl.substring(0, pos) + "/section/support?" + _fullSiteUrl.substring(pos + offsetStr.length) + "&m=0"; // e.g. http://www.sony-africa.com/section/home?site=hp_pt_AT_i
    }
    return urlfullSite;
}

////////////////////////////
function Wishlist() { }

Wishlist._get = function () {
    var value = Settings.get("wishlist");
    return (value != null) ? value.split("|") : [];
}

Wishlist.contains = function (id) {
    var ids = Wishlist._get();
    for (var i = 0; i < ids.length; i++) {
        if (id == ids[i]) return true;
    }
    return false;
}

Wishlist.add = function (id) {
    var ids = Wishlist._get();
    ids.push(id);
    Settings.set("wishlist", ids.join("|"));
    App.alert("Added to Wishlist!");
    History.reload();
}

Wishlist.remove = function (id) {
    var ids = Wishlist._get();
    var newids = [];
    for (var i = 0; i < ids.length; i++) {
        if (ids[i] != id) newids.push(ids[i]);
    }
    Settings.set("wishlist", newids.join("|"));
    App.alert("Removed from Wishlist!");
    History.reload();
}

Wishlist.clear = function () {
    Settings.set("wishlist", "");
    History.reload();
}

Wishlist.viewList = function () {
    Toolbar.setTitle(R.WISHLIST);
    Toolbar.addButton(R.CLEAR, "Wishlist.clear()");
    var ids = Wishlist._get();
    for (var i = 0; i < ids.length; i++) {
        var product = Query.selectId("products", ids[i]);
        if (product != null) {
            var subtitle = product.name;
            if (product.price > 0 && product.introdate <= today()) {
                var price = Format.price(product.price, product.currency, 0);
                subtitle += " " + price;
            }
            var style = "img:" + product.thumbnail;
            List.addItemSubtitle(product.code, subtitle, "viewProduct({product.id})", style);
        }
    }
    List.show();
    LeftPane.write();
}

//////////////////////////////
function viewAssetGroup(categoryid) {
    var galleries = Query.select("assetgroups", "id;name;imgurl", "categoryid CONTAINS {categoryid}", "name");
    for (var i = 0; i < galleries.length; i++) {
        var gallery = galleries[i];
        List.addItem(gallery.name, "viewAssetList({gallery.id})", "img:" + gallery.imgurl);
    }
    List.show();
}

function viewAssetList(groupid) {
    var photos = Query.select("assets", "id;name;imgurl;description", "groupid={groupid}", "name");
    for (var i = 0; i < photos.length; i++) {
        var photo = photos[i];
        List.addItem(photo.name, "viewAsset({photo.id})", "img:" + photo.imgurl);
    }
    List.show();
}

function viewAsset(id) {
    var photo = Query.selectId("assets", id);
    Toolbar.setStyle("nextprevious");
    List.addImage(photo.imgurl);
    List.addItemLabel("", photo.description);
    if (photo.url != "") List.addItem(R.MOREINFO, "App.web({photo.url})", "class=black");
    if (photo.productid != '') List.addItem(R.PRODUCTS2, "viewAssetProducts({photo.productid})", "class=black");
    List.show("form");
}

function viewAssetProducts(productid) {
    var where = "id IN " + list(productid);
    _writeProductList(where);
    List.show();
}

////////////////////////////

function termsOfUse() {
    window.open(_fullSiteUrl + "/section/termsofuse", "_blank");
}

function fullSite() {
    window.open(_fullSiteUrl + "/section/home?m=0", "_blank");
}

function privacyPolicy() {
    window.open(_fullSiteUrl + "/section/privacypolicy", "_blank");
}

function viewCountries() {
    var url = "http://www.sony.com.sg/HP/images/flag/";

    List.addHeader("Asia Pacific");
    List.addItem("Australia", "setCountry('au')", "scale:center;img:" + url + "AU_flag.png");
    if (Settings.getPlatform() == "mobileweb") List.addItem("India", "setCountry('in')", "scale:center;img:" + url + "IN_flag.png");
    List.addItem("Indonesia", "setCountry('id')", "scale:center;img:" + url + "ID_flag.png");
    List.addItem("Malaysia", "setCountry('my')", "scale:center;img:" + url + "MY_flag.png");
    List.addItem("New Zealand", "setCountry('nz')", "scale:center;img:" + url + "NZ_flag.png");
    List.addItem("Philippines", "setCountry('ph')", "scale:center;img:" + url + "PH_flag.png");
    List.addItem("Singapore", "setCountry('sg')", "scale:center;img:" + url + "SG_flag.png");
    List.addItem("Thailand", "setCountry('th')", "scale:center;img:" + url + "TH_flag.png");
    List.addItem("Vietnam", "setCountry('vn')", "scale:center;img:" + url + "VN_flag.png");

    if (Settings.getPlatform() == "mobileweb") {
        List.addHeader("Africa");
        List.addItem("Africa / English", "setCountry('af-en')", "img:" + url + "CentralAfrica_flag.png");
        List.addItem("Africa / Portuguese", "setCountry('at-pt')", "img:" + url + "CentralAfrica_flag.png");
        List.addItem("Africa / French", "setCountry('af-fr')", "img:" + url + "CentralAfrica_flag.png");
        List.addHeader("Middle East");
        List.addItem("Middle East / English", "setCountry('me-en')", "img:" + url + "ME_flag.png");
        List.addItem("Middle East / Arabic", "setCountry('me-ar')", "img:" + url + "ME_flag.png");
    }
    List.show("form");

}

function getCountry() {
    var storedCountry = Settings.get("country");
    if (storedCountry != null) {
        return storedCountry.toLowerCase();
    }

    if (Settings.getPlatform() == "mobileweb") {
        var host = document.location.hostname;
        if (host == "m.sony-mea.com") {
            return "mea";
        } else if (host == "m.sony-africa.com") {
            return "africa";
        } else if (host == "m.tw.sony-asia.com") {
            return "tw";
        } else {
            var country = host.substring(host.length - 2);
            return country;
        }
    } else {
        return Settings.getCountry().toLowerCase();
    }
}

var _fullSiteUrl;

function setCountry(country) {
    var supportPhone = "";
    var trackingId;
    var language = "en";
    var token;

    if (country == 'in') {
        token = "2/v5YYtZVYRmsLv54ul/7D+g7KgUtIND"; // Sony IN
        supportPhone = ""; // Custom buttons
        _fullSiteUrl = "http://www.sony.co.in";
        //trackingId = "UA-31705795-1";
    } else if (country == "my") {
        token = "6ssYO8DfaknuAzq2JtDxNaX5yPE7HYSB0"; // Sony MY
        supportPhone = "1300 88 1233";
        _fullSiteUrl = "http://www.sony.com.my";
        //trackingId = "UA-36184092-1";
    } else if (country == "au") {
        token = "AIirXMM8eWsX7PnI+OSBjqUuSWbmiYc1"; // Sony AU
        supportPhone = "1300 137 669";
        _fullSiteUrl = "http://www.sony.com.au";
        //trackingId = "UA-36127284-1";
    } else if (country == "nz") {
        token = "ob8zVqAryah2mdI43zx44D-g7KgUtIND0"; // Sony NZ
        supportPhone = ""; // Custom buttons
        _fullSiteUrl = "http://www.sony.co.nz";
        //trackingId = "UA-38149883-1";
    } else if (country == "th") {
        token = "inA/bcNdjsKt8Isc7ijonpz/mGeLmv1D"; // Sony TH
        supportPhone = "027156100";
        language = "th";
        _fullSiteUrl = "http://www.sony.co.th";
        //trackingId = "UA-36128468-1";
    } else if (country == "vn") {
        token = "uPs3Sn2rLbfvrA4xBoKBd6UuSWbmiYc10"; // Sony VN
        supportPhone = "1800588885";
        language = "vi";
        _fullSiteUrl = "http://www.sony.com.vn";
        //trackingId = "UA-36130586-1";
    } else if (country == "id") {
        token = "OJS19jHN42UYD4gftW6Hf8ha_Zz-H0BJ0"; // Sony Indonesia
        supportPhone = "021 2994 8800";
        _fullSiteUrl = "http://www.sony.co.id";
        //trackingId = "UA-36622196-1";
    } else if (country == "ph") {
        token = "kRmgEuDuj6lnICBG15ShBSTOD-ZyhDAM0"; // Sony Philippines
        supportPhone = "+6328787600";
        _fullSiteUrl = "http://www.sony.com.ph";
        //trackingId = "UA-37821161-1";
    } else if (country == "za") {
        token = "ejEhLBJ7diVI37w0pPFA9uNk-bfTuA9M0"; // South Africa
        supportPhone = ""; // Custom buttons
        _fullSiteUrl = "http://www.sony.co.za";
        //trackingId = "UA-37829013-1";
    } else if (country == "me-en") {
        token = "kZFRBjDwgdchU096kRi01Mha_Zz-H0BJ0";
        supportPhone = "+971 800 7669";
        _fullSiteUrl = "http://www.sony-mea.com";
        //trackingId = "UA-40436674-1";
    } else if (country == "me-ar") {
        token = "WpfglGHINbfHz3JCz1F3Qz-g7KgUtIND0";
        supportPhone = "+971 800 7669";
        language = "ar";
        _fullSiteUrl = "http://www.sony-mea.com/section/home?site=hp_ar_ME_i";
        //trackingId = "UA-40427563-1";
    } else if (country == "af-en") {
        token = "DDpmHXlAprmITPRNeiNJBuPKKJsYkmMd0";
        supportPhone = "+971 800 7669";
        language = "en";
        _fullSiteUrl = "http://www.sony-africa.com/section/home";
        //trackingId = "UA-40431355-1";
    } else if (country == "af-fr") {
        token = "-dFLUVIvMolX0kWt8MulHD-g7KgUtIND0";
        supportPhone = "+971 800 7669";
        language = "fr";
        _fullSiteUrl = "http://www.sony-africa.com/section/home?site=hp_fr_AF_i";
        //trackingId = "UA-40434452-1";
    } else if (country == "at-pt") {
        token = "CEI3NwrkflrJSlZ2l4AtEpcy05gCJXzd0";
        supportPhone = "+971 800 7669";
        language = "pt";
        _fullSiteUrl = "http://www.sony-africa.com/section/home?site=hp_pt_AT_i";
        //trackingId = "UA-40420271-1";
    } else if (country == "ir") {
        token = "MQmCvdjbm80OOnUBNdBmEz-g7KgUtIND0";
        supportPhone = "+98216460";
        language = "fa";
        _fullSiteUrl = "http://www.sony.co.ir";
        //trackingId = "UA-40421369-1";
    } else { // default is sg
        country = "sg";
        token = "ixo02aJTeKPO1wmWEhzffj+g7KgUtIND"; // Sony SG
        supportPhone = "6544 8600";
        _fullSiteUrl = "http://www.sony.com.sg";
        //trackingId = "UA-33750921-1";
    }

    if (Settings.getPlatform() != "mobileweb") {
        trackingId = "UA-22025843-1";
    } else {
        trackingId = "UA-33750921-1";
    }

    App.signInAuto(token, trackingId);
    Settings.set("supportphone", supportPhone);
    Settings.set("country", country);

    // set the web page site & header / footer
    if (Settings.getPlatform() == "mobileweb") {
        // Load strings for language
        _loadJS("res/sony." + language + ".js", false);

        document.title = "Sony " + getCountryName();
        _set("header", header());
        _set("footer", footer());
    }
}

function getCountryName() {
    var code = Settings.get("country");
    if (code == 'au') return R.AUSTRALIA;
    else if (code == 'id') return R.INDONESIA;
    else if (code == 'in') return R.INDIA;
    else if (code == 'nz') return R.NEWZEALAND;
    else if (code == 'my') return R.MALAYSIA;
    else if (code == 'sg') return R.SINGAPORE;
    else if (code == 'th') return R.THAILAND;
    else if (code == 'vn') return R.VIETNAM;
    else if (code == 'sg') return R.SINGAPORE;
    else if (code == 'ph') return R.PHILIPPINES;
    else if (code == 'za') return R.SOUTHAFRICA;
    else if (code == 'me-en' || code == 'me-ar') return R.MIDDLEEAST;
    else if (code == 'af-en' || code == 'af-fr' || code == 'at-pt') return R.AFRICA;
    else if (code == 'ir') return R.IRAN;
    else return "";
}

/*
function _TEST() {
    if (document == null) return false;
    return (document.location.hostname.indexOf("m.sony") == -1);
}
*/

function header() {
    var code = Settings.get("country");
    if (code == 'za' || code == 'ir') return;
    var onProducts = "CoreEngine.go('viewProducts()')";
    var onPromos = "CoreEngine.go('viewPromotions()')";
    var onStores = "CoreEngine.go('viewStoreLocator()')";
    var onSupport = "CoreEngine.go('viewSupport()')";
    var buf = [];
    buf.push('<table><tr><td onclick="CoreEngine.goHome()" class=border><img height=32px src=sonybig.png /></td>');
    buf.push('<td onclick="', onProducts, '" class=border>', R.PRODUCTS2, '</td>');
    if (code == 'me-en' || code == 'me-ar' || code == 'af-en' || code == 'af-fr' || code == 'at-pt') {
        buf.push('<td onclick="', onSupport, '" class=border>', R.SUPPORT, '</td>');
    } else {
        buf.push('<td onclick="', onPromos, '" class=border>', R.PROMOTIONS, '</td>');
    }
    buf.push('<td onclick="', onStores, '" class=border>', R.STORES, '</td>');
    buf.push('<td onclick="showSearch()"><div class="tb_sony_search"></div></td></tr></table>');
    return buf.join('');
}

function footer() {
    var country = Settings.get("country").toUpperCase();
    if (country == 'za' || country == 'ir') return;
    if (country.substring(0, 2) == "AF" || country.substring(0, 2) == "AT") country = "CentralAfrica";
    else if (country.substring(0, 2) == "ME") country = "ME";
    var countryFlagUrl = "http://www.sony.com.sg/HP/images/flag/" + country + "_flag.png";

    var buf = [];
    buf.push('<span onclick="termsOfUse()">' + R.TERMSOFUSE + '</span> <span style="float:right;" onclick="privacyPolicy()">' + R.PRIVACYPOLICY + '</span>');
    buf.push('<br /><br /><div style="text-align:right" id="flag"><img src="', countryFlagUrl, '" /></div>');
    return buf.join('');
}

function selectLanguage(region) {
    List.addHeader('Please select your preferred language');
    if (region == "mea") {
        List.addItem("English", "setCountry('me-en')");
        List.addItem("عربي", "setCountry('me-ar')");
    } else if (region = "africa") {
        List.addItem("English", "setCountry('af-en')");
        List.addItem("Português", "setCountry('at-pt')");
        List.addItem("Français", "setCountry('af-fr')");
    }
    List.show();
}

function addCss(direction) {

    var headtg = document.getElementsByTagName('head')[0];
    if (!headtg) {
        return;
    }
    var linktg = document.createElement('link');
    linktg.type = 'text/css';
    linktg.rel = 'stylesheet';
    if (direction == 'rtl')
        linktg.href = 'rtl.css';
    else
        linktg.href = 'ltr.css';

    headtg.appendChild(linktg);
}

////////////////////
function addSideBarItems() {
    Sidebar.clear();
    Sidebar.addItem(R.PRODUCTS2, "sony", "viewProducts()");
    Sidebar.addItem(R.PROMOTIONS, "sony", "viewPromotions()");
    Sidebar.addItem(R.STORES, "sony", "viewStoreLocator()");
    Sidebar.addItem(R.VIDEOS, "sony", "viewVideos()");
    Sidebar.addItem(R.NEWS, "sony", "viewNews()");
    //Sidebar.addItem(R.TECHNOLOGY, "sony", "viewTechnologies()");
    Sidebar.addItem(R.SUPPORT, "sony", "viewSupport()");
    Sidebar.addItem(R.WISHLIST, "sony", "Wishlist.viewList()");
    Sidebar.addItem(R.CHANGECOUNTRY, "sony", "viewCountries()");
}

//////////////////////////////
function Account() { }

Account.viewAccount = function () {
    if (Settings.get("signedin") != "1") {
        Account.signIn();
        return;
    }
    Toolbar.addButton("Sign out", "Account.signOut()");

    List.addItemLabel("Welcome to your My Sony Account", "You can register new products, view your products, check waranty dates and get repair status");
    List.addButton("Register New Product", "Account.registerProduct()");
    Account.writeProducts();
    List.show();
}

Account.signIn = function () {
    Toolbar.setTitle("My Sony");
    List.addHeader("Existing Sony Customer?");
    List.addTextBox("email", "Sony ID", "", "");
    List.addTextBox("password", "Password", "", "", "password");
    List.addButton("Sign In", "Account.onSignIn()");
    List.show();
}

Account.onSignIn = function () {
    Settings.set("signedin", "1");
    History.reload("Account.viewAccount()");
}

Account.signOut = function () {
    Settings.set("signedin", "0");
    History.reload();
}

Account._selProductId = null;

Account.registerProduct = function () {
    var retaillerOptions = Query.options("stores", "type<3");
    Toolbar.setTitle("Register Product");
    List.addBarcodeBox("code", "Scan Serial Number", "", "");
    if (Account._selProductId == null) {
        List.addItem("Select Product", "Account.selectProduct()", "icon=new");
    } else {
        var product = Query.selectId("products", Account._selProductId);
        List.addItemLabel("Product", product.code, "Account.selectProduct()");
    }
    List.addComboBox("retailer", "Place of Purchase", "", "", retaillerOptions);
    List.addTextBox("purchasedate", "Date of Purchase", '', '', "date");
    List.addButton("Submit", "History.reload('Account.onRegister()')");
    List.addHeader("Help");
    List.addItem("Where is my Serial Number?", "Account.showHelp()", "icon=arrow");
    List.show();
}

Account.showHelp = function () {
    var url = "https://www.sony.com.sg/HP/pages/html/sg/help/Product_Help.html#regserialno";
    WebView.show(url);
}

Account.selectProduct = function () {
    var categories = Query.select("categories", "id;name;thumbnail", null, "rank");
    for (var i = 0; i < categories.length; i++) {
        var category = categories[i];
        var count = Query.count("products", "categoryid CONTAINS {category.id}");
        var onclick = "Account.selectProduct2({category.id})";
        if (count > 0) List.addItem(category.name, "History.reload({onclick})", "class:category;img:" + category.thumbnail);
    }
    List.show();
}

Account.selectProduct2 = function (categoryid) {
    Toolbar.setStyle("search");
    var products = Query.select("products", "id;name;code;thumbnail", "categoryid CONTAINS {categoryid}", "code");
    for (var i = 0; i < products.length; i++) {
        var product = products[i];
        var subtitle = product.name;
        var style = "img:" + product.thumbnail;
        List.addItemSubtitle(product.code, subtitle, "Account.onSelectProduct({product.id})", style);
    }
    List.show();
}

Account.onSelectProduct = function (id) {
    Account._selProductId = id;
    History.back();
}

Account.onRegister = function () {
    _selProductId = null;
    // TODO : send registration
    Toolbar.setTitle("Registration Complete");
    List.addItemLabel("Thanks your for submitting your product registration", "It will take few hours to validate your product registration. Your new product will appear in your My Sony Account on your phone.");
    List.addButton("Close", "History.back()");
    List.show();
}

Account.writeProducts = function () {
    ids = ['NWZ-B173F/LCE', 'SGPT132A1/S E1', 'PCH-1006 ZA01'];
    if (ids.length == 0) return;

    List.addHeader("My Products" + " (" + ids.length + ")");
    for (var i = 0; i < ids.length; i++) {
        var product = Query.selectId("products", ids[i]);
        if (product != null) {
            var subtitle = product.name;
            var style = "img:" + product.thumbnail;
            List.addItemSubtitle(product.code, subtitle, "Account.viewMyProduct({product.id})", style);
        }
    }
}

Account.viewMyProduct = function (id) {
    var product = Query.selectId("products", id);
    var firstProductImageUrl = getFirstProductImageUrl(id, '');

    Toolbar.setTitle(R.PRODDETAILS);
    if (firstProductImageUrl != null) List.addImage(firstProductImageUrl, "viewGallery({id})", "height=180px;class=productimage");
    List.addItemLabel(product.code, product.name, null, "class=productcode");
    List.addItemLabel("Under Waranty until", Format.date(today() + 30 * DAY));
    List.addItemLabel("Purchase Date", Format.date(today() - 90 * DAY));
    List.addItemLabel("Purchase Place", "Best Denki");
    List.addButton("View Product Page", "viewProduct({id})");
    List.show();
}

////////////////////////////////////

function _groupcount(items, fieldName) {
    var map = new Array();
    for (var i = 0; i < items.length; i++) {
        var item = items[i];
        var value = item[fieldName];
        if (value != null) {
            var values = value.split('|');
            for (var j = 0; j < values.length; j++) {
                var count = map[values[j]];
                if (count == null) {
                    map[values[j]] = 1;
                } else {
                    map[values[j]] = count + 1;
                }
            }
        }
    }
    return map;
}

////////////////////////////////////////
function LeftPane() { }

LeftPane.writeProduct = function (id) {
    //if (Settings.isTablet() == false) return; NB We write it in all cases because on the Phablet we must keep track of the left pane even if we are in portrait mode
    if (Settings.getPlatform() == "mobileweb") return;

    var product = Query.selectId("products", id);
    var reviewCount = Query.count("reviews", "productid={id}");
    var galleryCount = Query.count("assetgroups", "categoryid CONTAINS {product.categoryid}");
    var videoCount = Query.count("videos", "productid CONTAINS {id}");
    var promo = _getProductPromotion(product.promotionid);
    var productUrl = product.url.toLowerCase();

    List.addItem("Overview", "viewProduct({id})", "icon=arrow");
    List.addItem(R.SPECS, "viewSpec({id})", "icon=arrow");
    List.addItem(R.PHOTOGALLERY, "viewGallery({id})", "icon=arrow");
    if (galleryCount > 0) List.addItem(R.SAMPLEPHOTOS, "viewAssetGroup({product.categoryid})", "icon=arrow");
    if (promo != null) List.addItem(R.PROMOTION, "viewPromotion({promo.id})", "icon=arrow");
    if (reviewCount > 0) List.addItem(R.REVIEWS, "viewReviews({id})", "icon=arrow");
    if (product.parentid != '') {
        List.addItem(R.COMPATIBILITY, "viewCompatibility({product.parentid})", "icon=arrow");
    } else {
        var accessoriesCount = Query.count("products", "parentid CONTAINS {id}");
        if (accessoriesCount > 0) List.addItem(R.ACCESSORIES, "viewAccessories({id})", "icon=arrow");
    }
    List.addItem(R.WHERETOBUY, "viewStoreLocatorForCategory({product.categoryid})", "icon=arrow");

    var country = Settings.get("country");
    buyLabel = (country == "au" || country == "nz") ? R.BUYNOW : R.VIEWINFULLSITE;
    var urlfullSite = productUrl + "?m=0";
    List.addItem(buyLabel, "App.web({urlfullSite})", "icon=arrow");

    List.setStyle("keephistory");
    List.show("leftpane");
}

LeftPane.write = function () {
    //if (Settings.isTablet() == false) return; NB We write it in all cases because on the Phablet we must keep track of the left pane even if we are in portrait mode
    if (Settings.getPlatform() == "mobileweb") return;

    List.addItem("Home", "main()");
    List.addItem(R.PRODUCTS2, "viewProducts()");
    List.addItem(R.PROMOTIONS, "viewPromotions()");
    List.addItem(R.STORES, "viewStoreLocator()");
    List.addItem(R.VIDEOS, "viewVideos()");
    List.addItem(R.NEWS, "viewNews()");
    //List.addItem(R.TECHNOLOGY, "viewTechnologies()");
    List.addItem(R.SUPPORT, "viewSupport()");
    List.addItem(R.WISHLIST, "Wishlist.viewList()");
    List.addItem(R.CHANGECOUNTRY, "viewCountries()");
    List.show("leftpane");
}

/////////////////////////////////

function _groupcount(items, fieldName) {
    var map = new Array();
    for (var i = 0; i < items.length; i++) {
        var item = items[i];
        var value = item[fieldName];
        if (value != null) {
            var values = value.split('|');
            for (var j = 0; j < values.length; j++) {
                var count = map[values[j]];
                if (count == null) {
                    map[values[j]] = 1;
                } else {
                    map[values[j]] = count + 1;
                }
            }
        }
    }
    return map;
}